import { Controller, Get, Query } from '@nestjs/common';
import { ApiOperation, ApiQuery, ApiTags } from '@nestjs/swagger';
import { Serealize } from '../interceptors/serialize.interceptor';
import { InstitucionCarreraService } from './institucion-carrera.service';
import { IdInstitucionDto } from '../dto/input/id-institucion.dto';
import { InstitucionCarreaOutputDto } from './dto/output/institucion-carrera.dto';

@Controller('institucion-carrera')
@ApiTags('institucion-carrera')
export class InstitucionCarreraController {
  constructor(private institucionCarreraService: InstitucionCarreraService) {}

  @Serealize(InstitucionCarreaOutputDto)
  @Get()
  @ApiOperation({
    description: 'Endpoint que retorna todas las carreras de una institución.',
  })
  @ApiQuery({
    description: 'Id de la institución.',
    name: 'id_institucion',
    type: 'string',
  })
  get(@Query() query: IdInstitucionDto) {
    return this.institucionCarreraService.findAllByIdInstitucion(
      parseInt(query.id_institucion),
    );
  }

  @Serealize(InstitucionCarreaOutputDto)
  @Get('institucion-profesor')
  @ApiOperation({
    description: 'Endpoint que retorna todas las carreras de una institución.',
  })
  @ApiQuery({
    description: 'Id de la institución.',
    name: 'id_institucion',
    type: 'string',
  })
  institucionProfesor(@Query() query: IdInstitucionDto) {
    return this.institucionCarreraService.findInstitucionProfesor(
      parseInt(query.id_institucion),
    );
  }
}
